function [f,g] = dtlz5(x)

if nargin == 0
	prob.nx = 12;
	prob.nf = 3;
	prob.ng = 0;
	prob.range = cell(1, prob.nx);
	for i = 1:prob.nx
		prob.range{i} = Range('range', [0,1]);
	end
	f = prob;
else
	[f,g] = dtlz5_true(x);
end
return


function [f,g] = dtlz5_true(x)

M = 3;
k= 10;

theta = zeros(1,M-1);

temp = x(M:M+k-1)-0.5*ones(1,k);
G = temp*temp';

theta(1) = x(1)*pi/2;

for i = 2:M-1
    theta(i) = pi*(1+2*G*x(i))/(4*(1+G));
end

% theta(2:M-1) = pi*(1+2*G*x(2:M-1))/(4*(1+G));
% theta = theta*pi/2;

f(1) = (1+G)*prod(cos(theta));
for j = 2:M-1
    f(j) = (1+G)*prod(cos(theta(1:M-j)))*sin(theta(M-j+1));
end
f(M) = (1+G)*sin(theta(1));

g = [];
 
return
