%% Create samples
function [inst] = sample(num, N, method, arg)

if nargin < 2, N = 1; end
if nargin < 3, method = 'uniform'; end
if nargin < 4, arg = []; end

inst = cell(N, 1);
if method == 'special'
	inst{1} = Numeric_repr(num, arg);
	for i = 2:N
		x = mutation_POLY(num, arg);
		inst{i} = Numeric_repr(num, x);
	end
else
	for i = 1:N
		x = sample_single(num, method, arg);
		inst{i} = Numeric_repr(num, x);
	end
end
return


%% Sample single instance
function [x] = sample_single(num, method, arg)

x = zeros(1, num.nx);

switch method
	case 'uniform'
		for j = 1:num.nx
			x(j) = sample(num.range{j});
		end
		
	otherwise
		error('Sampling method not implemented (%s)', method);
end
return
