%% Load parameters from params.m
function [ps] = load(ps, param)

if isempty(param)
	try
		t = fileread('params.m');
		eval(t);
	end
end

fields = fieldnames(ps.param);
err = 0;
for i = 1:length(fields)
	key = fields{i};
	if isfield(param, key)
		verify(ps.param.(key), param.(key), key);
		ps.value.(key) = param.(key);
	else
		fprintf('%s not defined\n', key);
		err = 1;
	end
end

if err == 1
	error('Some of the required parameters are not defined');
end
return
