%% Population class (place holder for individuals)
function [pop] = Population(object, size, prob)
% Create population of object instances

% input - problem definition and parameters
% input - or template population

pop.object = [];

pop.size = 0;
pop.nf = 0;
pop.ng = 0;

pop.x = {};
pop.f = [];
pop.g = [];

pop.feas = [];
pop.rank = [];
pop.age = [];
pop.eval = [];

pop.cv = [];
pop.nd_rank = [];
pop.crowd = [];
pop.fn_evals = 0;

pop = class(pop, 'Population');

if nargin > 0
	if nargin == 2
		assert(isa(object, 'Population'));
		pop = object;
		pop.size = size;
	elseif nargin == 3
		pop.object = object;
		pop.size = size;	
		pop.nf = prob.nf;					% number of objectives
		pop.ng = prob.ng;					% number of constraints
	else
		error('Wrong number of arguments');
	end

	pop.x = cell(pop.size, 1);			% Instances
	pop.f = zeros(pop.size, pop.nf);	% Objectives
	pop.g = zeros(pop.size, pop.ng);	% Constraints
	pop.feas = zeros(pop.size, 1);		% Solution feasibility
	pop.rank = zeros(pop.size, 1);		% Solution Rank
	pop.age = zeros(pop.size, 1);		% Solution age
	pop.eval = zeros(pop.size, 1);		% Evaluation flag
	pop.cv = zeros(pop.size, 1);	% Constraint Violation
	pop.nd_rank = zeros(pop.size, 1);	% ND Rank
	pop.crowd = zeros(pop.size, 1);		% Crowding distance
end

return
