function [pop] = sort_idea(pop, inf_ratio, f_new)

feasible = find(pop.feas == 1);
infeasible = find(pop.feas == 0);

% sort feasible solutions
ranks1 = [];
if ~isempty(feasible)
	F = sort_nd(pop.f, feasible);
	for front = 1 : length(F)
		pop.nd_rank(F(front).f(:)) = front;
		[r1, d1] = sort_crowding(pop.f, F(front).f);
		pop.crowd(F(front).f(:)) = d1;
		ranks1 = [ranks1; r1];
	end
end

% sort infeasible solutions
ranks2 = [];
if ~isempty(infeasible)
	if length(infeasible) == pop.size
		ranks2 = sort_constr(pop.cv, infeasible);
	else
		F = sort_nd([pop.f f_new], infeasible);
		for front = 1 : length(F)
			pop.nd_rank(F(front).f(:)) = -front;
			[r1, d1] = sort_crowding([pop.f f_new], F(front).f);
			pop.crowd(F(front).f(:)) = d1;
			ranks2 = [ranks2 ; r1];
		end
	end
end

assert(length(ranks1)+length(ranks2) == pop.size);
pop.rank = [ranks1; ranks2];

N_inf = min(sum(pop.feas == 0), round(inf_ratio/2 * pop.size));

% promote infeasible solutions
if length(infeasible) < pop.size
	new_rank = zeros(pop.size,1);
	index1 = 1;
	index2 = N_inf + 1;
	for i = 1:pop.size
		id = pop.rank(i);
		if pop.feas(id) == 0 && index1 <= N_inf
			new_rank(index1) = id;
			index1 = index1+1;
		else
			new_rank(index2) = id;
			index2 = index2 + 1;
		end
	end
	pop.rank = new_rank;
% 	pop.rank(1:N_inf) = new_rank(N_inf+1:2*N_inf);
% 	pop.rank(N_inf+1:2*N_inf) = new_rank(1:N_inf);
% 	pop.rank(2*N_inf+1:end) = new_rank(2*N_inf+1:end);
end

return
