function [pop] = sort_nd_maxcv_unique(pop)

feasible = find(pop.feas == 1);
infeasible = find(pop.feas == 0);

ranks1 = [];
ranks1_dup = [];
if ~isempty(feasible)
	if pop.nf == 1
		[tmp, I] = sort(pop.f(feasible));
		[tmp2, J] = unique(tmp);
		ranks1 = feasible(I(J));
		J2 = setdiff((1:length(feasible))', J);
		ranks1_dup = feasible(I(J2));
	else
		F = sort_nd(pop.f, feasible);
		for front = 1 : length(F)
			pop.nd_rank(F(front).f(:)) = front;
			[r1, d1] = sort_crowding(pop.f, F(front).f);
			pop.crowd(F(front).f(:)) = d1;
			ranks1 = [ranks1; r1];
		end
	end
end

ranks2 = [];
ranks2_dup = [];
if ~isempty(infeasible)
	[tmp, I] = sort(pop.cv(infeasible), 'descend');
	[tmp2, J] = unique(tmp);
	ranks2 = infeasible(I(J));
	J2 = setdiff((1:length(infeasible))', J);
	ranks2_dup = infeasible(I(J2));
end

assert(length(ranks1) + length(ranks1_dup) + length(ranks2) + length(ranks2_dup) == pop.size);
pop.rank = [ranks1; ranks2; ranks1_dup; ranks2_dup];
return
